// note this is adapted from:
// http://www.java-samples.com/showtutorial.php?tutorialid=306a

Lock* lock = new Lock( "lock" );
Condition* condition = new Condition( "condition" );
int sharedItem = -1;
bool valueSet = false;

// gets the item, if it's available
// if it's not available, then it waits until the item becomes available 
int getItem() {
  printf( "Getting..." );
  currentThread->Print();
  printf( "\n" );
  lock->Acquire();

  while ( !valueSet ) {
    condition->Wait( lock );
    // when Wait() returns, the lock has been reacquired
  }

  valueSet = false;
  
  // note that the broadcast must occur BEFORE releasing the lock
  condition->Broadcast( lock );
  lock->Release();

  currentThread->Print();
  printf( " is returning\n" );

  return sharedItem;
}

void getAndPrintItem( int junk ) {
  int item = getItem();
  currentThread->Print();
  printf( " got %i\n", item );
}

// puts an item, if there is space to do so
// if there isn't space, then it waits until there is space
void setItem( int item ) {
  printf( "Setting..." );
  currentThread->Print();
  printf( "\n" );
  lock->Acquire();

  while ( valueSet ) {
    condition->Wait( lock );
  }

  sharedItem = item;
  valueSet = true;
  condition->Broadcast( lock );
  lock->Release();
  currentThread->Print();
  printf( "is returning\n" );
}

void queueTest() {
  Thread* prod1 = new Thread( "prod1" );
  prod1->Fork( setItem, 1 );
  Thread* prod2 = new Thread( "prod2" );
  prod2->Fork( setItem, 2 );
  Thread* cons1 = new Thread( "cons1" );
  cons1->Fork( getAndPrintItem, 0 );
  Thread* cons2 = new Thread( "cons2" );
  cons2->Fork( getAndPrintItem, 0 );
}
